/*******************************************************************
*
*                       Cinepak for SATURN Player 
*                                by SOJ
*
*                      Copyright(c) 1994,1995 SEGA
*
*   Comment: pҗpwb_
*   File   : SEGA_CPK.H
*   Date   : 1995-01-06
*   Version: 1.06
*   Author : Y.T
*
*******************************************************************/
#ifndef SEGA_CPK_H
#define SEGA_CPK_H


/*-------------------- sCN[ht@Ct --------------------*/
#include "sega_xpt.h"
#include "sega_gfs.h"
#include "sega_stm.h"

/*------------------------- s}N萔t -------------------------*/
/* nh */
#define CPK_HN_MAX				(32)

/* G[R[h	*/
typedef enum {
	CPK_ERR_OK					= 0x00000000,/* G[͔ĂȂ		*/

	/* CPK_Create ̃G[ */
	CPK_ERR_OUT_OF_HANDLE		= 0x00000101,/* nh؂ 			*/
	CPK_ERR_TOO_SMALL_BUF		= 0x00000102,/* ݸޯ̧ނ	*/
	CPK_ERR_NO_INIT				= 0x00000103,/* ֐قĂȂ 	*/

	/* CPK_Destroy ̃G[ */
	CPK_ERR_INVALID_HN			= 0x00000201,/* sȃnhŏ		*/
	CPK_ERR_ILL_CREATE_MODE		= 0x00000202,/* Create ̃[hƈႤ		*/

	/* cpk_HeaderProcess ̃G[ */
	CPK_ERR_TOO_SMALL_FLOP		= 0x00000301,/* FLOPl		*/
	CPK_ERR_TOO_LARGE_HEADER	= 0x00000302,/* wb_傷			*/
											/* (ݸޯ̧ނ)	*/
	CPK_ERR_HEADER_DATA			= 0x00000303,/* wb_f[^G[ 			*/
	CPK_ERR_TOO_SMALL_PCMBUF	= 0x00000304,/* PCMޯ̧ނ	*/
	CPK_ERR_ILL_SIZE_PCMBUF		= 0x00000305,/* PCMޯ̧ޕs 4096*2`16	*/

	/* cpk_VideoSample ̃G[ */
	CPK_ERR_SAMPLE_ID			= 0x00000401,/* ʎqG[B00h,01h ȊO*/
	CPK_ERR_SAMPLE_DATA			= 0x00000402,/* sf[^B				*/

	/*  */
	CPK_ERR_ILLEGAL_PARA		= 0x00000503,/* ̎w肪ԈĂ 	*/
	CPK_ERR_ILLEGAL_HANDLE		= 0x00000504,/* nhُ 				*/

	/* AĐɊւG[ */
	CPK_ERR_NEXT_MOVI_STATUS	= 0x00000601,/* AĐѰް̏Ԉُ 	*/
	CPK_ERR_NEXT_MOVI_AUDIO		= 0x00000602,/* I[fBȈvȂ */
	CPK_ERR_NEXT_MOVI_SCALE		= 0x00000603,/* ^CXP[vȂ 	*/
	CPK_ERR_CHANGE_NO_DATA		= 0x00000604,/* f[^sԂŃ`FW */
	CPK_ERR_CHANGE_NO_ENTRY		= 0x00000605,/* GgȂԂŃ`FW */

	/* |[YɊւG[ */
	CPK_ERR_PAUSE_STATUS		= 0x00000701,/* CPK_STAT_PLAY_TIME, ܂́A
											 * CPK_STAT_PLAY_PAUSE ȊO
											 * ԂŃ|[Y֐R[B
											 */

	/* DMA]ɊւG[ */
	CPK_ERR_DMA_MODE			= 0x00000801,/* Ή̓] 			*/
	CPK_ERR_DMA_CPU_PCM			= 0x00000802,/* CPUDMAُI 			*/

	/* t@Cǂݍ݃G[ */
	CPK_ERR_GFS_READ			= 0x00000901,/* fer̓ǂݍ݂Ŏs 		*/

	/* CPK_DecodeFrameɊւG[ */
	CPK_ERR_DF_NO_DATA			= 0x00000A01,/* wb_̃f[^Ȃ 	*/
	CPK_ERR_DF_IS_NOT_VIDEO		= 0x00000A02,/* rfITvłȂ 		*/


	CPK_ERR_END
} CpkErrCode;

/* ĐXe[^X */
typedef enum {
	CPK_STAT_PLAY_ERR_STOP		= -1,		/* ُ~					*/
	CPK_STAT_PLAY_STOP			= 0,		/* ~ 					*/
	CPK_STAT_PLAY_PAUSE			= 1,		/* ꎞ~		 			*/
	CPK_STAT_PLAY_START			= 2,		/* Jn						*/
	CPK_STAT_PLAY_HEADER		= 3,		/* wb_ݒ@				*/
	CPK_STAT_PLAY_TIME			= 4,		/* Đ(^C}X^[g)		*/
	CPK_STAT_PLAY_END			= 5			/* Đ 				*/
} CpkPlayStatus;

/* ꎞ~̐R}h */
typedef enum {
	CPK_PAUSE_ON_AT_ONCE,					/* ꎞ~ 			*/
	CPK_PAUSE_ON_KEYFRAME,					/* L[t[҂ꎞ~	*/
	CPK_PAUSE_OFF							/* ꎞ~ 			*/
} CpkPauseCmd;

/* \F[bit] */
typedef enum {
	CPK_COLOR_24BIT				= 24,		/* 1600F 				*/
	CPK_COLOR_15BIT				= 15		/* 32000F 					*/
} CpkColorType;

/* ؂ւ\`FbNl */
typedef enum {
	CPK_CHANGE_OK_AT_ONCE		= 0,	/* ؂ւ\B			*/
	CPK_CHANGE_NO_DATA			= 1,	/* f[^sB				*/
	CPK_CHANGE_NO_ENTRY			= 2,	/* GgB				*/
	CPK_CHANGE_TOO_LARGE_HEADER	= 3		/* wb_傷B			*/
										/* (obt@TCY)	*/
} CpkChangeStatus;

/* 摜L^C~O̐ݒl */
typedef enum {
	CPK_DEC_TIMING_DECODE_IN_HASTE = 0,	/* 肠LĂ		*/
	CPK_DEC_TIMING_WAIT_AND_DECODE = 1	/* \҂ĐL		*/
} CpkDecTiming;

/* f[^̓] */
typedef enum {
	CPK_TRMODE_CPU = 0,					/* \tgEFA] 			*/
	CPK_TRMODE_SDMA,					/* cl`TCNX`[ 		*/
	CPK_TRMODE_SCU						/* rbt̂cl`				*/
}  CpkTrMode;

/* [] CPK_SetTrModePcm(Oobt@->oblobt@)̏ꍇ CPK_TRMODE_SCU ͎g܂B*/

/*------------------------- s}Nt -------------------------*/
/* 쐬p[^ւ̃ANZX}N */
#define	CPK_PARA_WORK_ADDR(para)	((para)->work_addr)
#define	CPK_PARA_WORK_SIZE(para)	((para)->work_size)
#define	CPK_PARA_BUF_ADDR(para)		((para)->buf_addr)
#define	CPK_PARA_BUF_SIZE(para)		((para)->buf_size)
#define	CPK_PARA_PCM_ADDR(para)		((para)->pcm_addr)
#define	CPK_PARA_PCM_SIZE(para)		((para)->pcm_size)

/* Code1Book̃TCY [byte],[dbyte] */
#define CPK_BSIZE_CODE1BOOK				(0x800)
#define CPK_BSIZE_CODE1BOOK_FUL			(2 * CPK_BSIZE_CODE1BOOK)
#define CPK_DSIZE_CODE1BOOK				(CPK_BSIZE_CODE1BOOK     / 4)
#define CPK_DSIZE_CODE1BOOK_FUL			(CPK_BSIZE_CODE1BOOK_FUL / 4)

/* QStJ[p̃[Nobt@TCY */
#define	CPK_24WORK_BSIZE	sizeof(CpkWork)
#define	CPK_24WORK_DSIZE	(CPK_24WORK_BSIZE / 4)

/* PTJ[p̃[Nobt@TCY */
#define	CPK_15WORK_BSIZE	(sizeof(CpkWork) - (4 * CPK_BSIZE_CODE1BOOK))
#define	CPK_15WORK_DSIZE	(CPK_15WORK_BSIZE / 4)


/*-------------------------- sf[^^t --------------------------*/
/* [rnh */
typedef void *CpkHn;

/* 쐬p[^ */
typedef struct {
	Uint32		*work_addr;		/* [N̐擪AhX */
								/* {Cu[rĐ鎞̍Ɨ̈*/
	Uint32		work_size;		/* [ÑoCg */
								/* CPK_BSIZE_WORK w肷 */
	Uint32		*buf_addr;		/* Ѱ̧قi[obt@̐擪AhX */
								/* ̃[rt@C̎͂̃AhX */
								/* CD̃[rt@C̎ݸޯ̧̱ڽ */
	Uint32		buf_size;		/* obt@TCY */
								/* ̃[rt@C̎̓t@CTCY*/
								/* CD̃[rt@C̎ݸޯ̧̃TCY */
	Uint16		*pcm_addr;		/* TEhPCMobt@AhX 		*/
	Uint32		pcm_size;		/* TEhPCMobt@TCY		*/
								/* (1ch̃Tv(4096*1..4096*16))		*/
} CpkCreatePara;


/* tBTve[u */
typedef struct {
	Uint32		offset;				/* fBAJnʒũItZbg */
	Sint32		size;				/* TvTCY 					*/
	Sint32		time;				/* t[\A-1:ި */
	Sint32		duration;			/* t[\ 			*/
} CpkFilmSample;


/* tBwb_ */
typedef struct {
	/* FilmHeader */
	Uint32		film;				/* "FILM" 								*/
	Uint32		size_header;		/* wb_TCY(fBAJnւ̵̾)	*/
	Uint32		version;			/* o[W 							*/
	Uint32		reserved;			/* \ 								*/
	/* FrameDescription */
	Uint32		fdsc;				/* "FDSC" 								*/
	Uint32		size_fdsc;			/* FDSCTCY 0x0000001C = 7*4[byte]	*/
	Uint32		c_type;				/* k "cvid" 						*/
	Uint32		height;				/* ĕ[pixel]						*/
	Uint32		width;				/* 悱[pixel] 						*/
	Uint8		color;				/* \F[bit] 						*/
	Uint8		sound_channel;		/* `l 							*/
	Uint8		sound_smpling_bit;	/* TvOrbg[bit] 			*/
	Uint8		sound_compress;		/* k 00h: 01h:ADPCM 				*/
	Uint32		sound_smpling_rate;	/* ݸڰ[Hz] ʂQbyte͏ 	*/
	Uint32		ckey;				/* N}L[	 					*/
	/* FilmSampleTable */
	Uint32		stab;				/* "STAB" 								*/
	Uint32		size_stab;			/* STABTCY (ِ+1)*16[byte] 	*/
	Uint32		time_scale_film;	/* ^CXP[ 						*/
	Uint32		sample_total;		/* Tv 						*/
	CpkFilmSample sample[1];		/* Tve[u CӃTCY 			*/
} CpkHeader;

/* G[o^֐ */
typedef void (*CpkErrFunc)(void *obj, Sint32 err_code);


/* p[^ */
typedef struct {
	Uint32		AddrBuf;		/* obt@JnʒuBV̏ꍇ 0x4000000 	*/
	Uint32		SizeBuf;		/* obt@TCYB@V̏ꍇ 0x1000000 	*/
	Uint32		size_trigger;	/* ĐJngKTCY						*/
	Uint32		AddrVram;		/* 摜o̓AhX 						*/
	Uint32		SizeVramLine;	/* 摜o̓obt@sTCY[byte]			*/
	/* TEhhCo֘A */
	Uint32		play_pcm;		/* PCMĐtO 0:̏Ȃ 1:Đ		*/
	Uint32		command_blk_no;	/* TEhhCoR}hubNԍ 	*/
	Uint32		pcm_stream_no;	/* PCMXg[Đԍ 					*/
	Uint16		*addr_pcmbuf;	/* ؂PCMobt@AhX 			*/
	Uint32		size_pcmbuf;	/* ؂PCMobt@TCY[sample/1ch] 	*/
	Uint32		pcm_pan;		/* 0..31	*/
	Uint32		pcm_level;		/* 0..7		*/
	Uint32		frequency_vbl;	/* CPK_VblIn()R[g[256*Hz] 	*/
} CpkPara;

/* DMA] */
typedef struct {
	Uint32		dst;				/* ]AhX 						*/
	Uint32		src;				/* ]AhX 						*/
	Uint32		cnt;				/* ] 							*/
} CpkDmaStock;

/* e */
typedef struct {
	/* S̐ */
	Sint32		stat_start;			/* Xe[^X̊Jn						*/
	Sint32		play;				/* Đ 							*/
	Uint32		RequestDispFrame;	/* t[\vtO 				*/
	Uint32		CntSample;			/* TvJE^ 					*/
	Uint32		CntFrame;			/* t[JE^ 					*/
	Uint32		offset_media;		/* fBAJnʒuւ̃ItZbg		*/
	Uint32		display_keyframe;	/* \摜L[t[tO 			*/
	Uint32		standby_keyframe;	/* ҋ@摜L[t[tO 			*/
	Uint32		standby_video_flag;	/* \ҋ@摜tO 				*/
	Uint32		standby_time_display;/* ҋ@摜̕\					*/
	Uint32		standby_time_duration;/* ҋ@摜̕\				*/
	Uint32		only_audio;			/* flag that only audio sample 			*/
	Uint32		only_video;			/* flag that only video sample 			*/
	Uint32		color;				/* o͐F[bit]B15 or 24				*/
	Uint32		wait_keyframe_to_pause;/* ꎞ~pڰё҂tO 	*/
	Uint32		wait_and_decode;	/* 1:\҂ĂL		*/
	Sint32		flag_prohibit_komaotoshi;/* 1:R}ƂkinnshitO		*/
	Sint32		ckey_cutoff;		/* chroma key cutoff level 				*/
	
	/* Oobt@ */
	Uint32		OffsetWrite;		/* obt@ǂ݁Eʒu[byte]			*/
	Uint32		OffsetRead;			/* (t@C擪̃ItZbg)		*/
	Uint32		AddrWrite;			/* obt@ǂ݁Eʒu(AhX)		*/
	Uint32		AddrRead;			/* 										*/
	Uint32		AddrRing;			/* Oobt@JnAhX 			*/
	Uint32		AddrRingEnd;		/* Oobt@IAhX 			*/
	Sint32		SizeHead;			/* wb_obt@TCY [byte] { */
	Uint32		SizeRing;			/* Oobt@TCY [byte] { */
	Uint32		SizeFlop;			/* eknoobt@TCY [byte] 		*/
	
	/* PCMĐ */
	Uint32		play_pcm;			/* PCMĐtO 0:̏Ȃ 1:Đ	*/
	Uint32		bsize_pcmbuf;		/* ؂PCMobt@TCY[byte/1ch]*/
	Uint16		*addr_pcmbuf_end;	/* PCMobt@IAhX 				*/
	Uint16		*addr_pcm_write;	/* PCMobt@݃AhX 			*/
	Uint32		smpling_rate;		/* ݸڰ[Hz] ʂPbyte͏ 	*/
	Uint32		cnt_4ksample;		/* PCM play address 4kْPʍXV */
	Sint32		flag_fill_silence;	/* ݒς݃tO					*/
	Sint32		sample_write;		/* Tv[sample]				*/
									/* (擪̨т݂̌܂ł̑)	*/
	Sint32		sample_film_start;	/* tBJnTv[sample]		*/
									/* (擪̨т猻̨ъJn_܂ł)	*/
	Sint32		sample_pause;		/* |[YTv[sample]			*/
									/* (擪̨тŋ߂̃|[Y_܂ł)	*/
	Sint32		count_start;		/* botNbN^C}Jn 		*/
									/* 						[CPUۯ>>15] 	*/
	Sint32		clock_scale;		/* botNbN^C}̃XP[ 		*/
	
	/* PCMf[^̂cl`]Ɋւ */
	CpkTrMode	copy_mode_pcm;		/* f[^̓] 					*/
	Uint32		flag_dma_hold;		/* 1:̃[r[DMAێĂ*/
	Uint32		pcm_renew_size;		/* DMAIpcmޯ̧߲XV*/
	Uint32		buf_renew_size;		/* DMAIޯ̧ǂݎ߲XV 	*/
	Uint32		idx_dma_pcm_tbl;	/* dma_pcm_tbl ̃CfbNX 			*/
	CpkDmaStock	dma_pcm_tbl[4];		/* DMA]Gge[u 			*/
	
	/* ԊǗ(rfÎ݃[r[p) */
	Sint32		vbl_film_start;		/* tBJn[vbl] 				*/
	Sint32		vbl_pause;			/* |[YJn[vbl] 					*/
	Sint32		time_frame;			/* \t[̕\{	*/
	
	/* G[ */
	Uint32		err_start;			/* G[̊Jn                     */
	Uint32		CntLossFrame;		/* R}JE^ 					*/
	Uint32		CntPcmLoadMiss;		/* PCM[h~XJE^ 				*/
	Uint32		CntCallTask;		/* ^XNR[JE^ 				*/
	Uint32		CntOverCallTask;	/* ߏ^XNR[JE^ 			*/
	Uint32		cnt_buf_empty;		/* obt@^XNJE^ 			*/
	Uint32		max_late_time;		/* őxꎞ[tBԒP] 		*/
	Uint32		max_late_frame;		/* őxt[ԍ					*/
} CpkStatus;


/* t@CANZX֌W */
typedef struct {
	GfsHn		gfs;			/* t@Cnh */
	Sint32		load_sect;		/* ]őZN^ */
	Bool		exec_one_state;	/* ExecOne sȂ TRUE */
	Sint32		exec_load_size;	/* ExecOne œǂݍރoCg */
	Sint32		now_load_size;	/* ExecOne œǂݍłoCg */
	Sint32		load_total_sect;/* ǂݍݑZN^ */
	Sint32		file_sect;		/* t@C̃ZN^ */
	Sint32		tr_mode;		/* ][h */
} CpkFileGfsPara;

typedef struct {
	StmHn		stm;			/* Xg[nh */
	Sint32		load_sect;		/* ]őZN^ */
	Sint32		old_cd_buf_num;	/* Ôbcobt@̐ */
	Bool		dma_state;		/* cl`]ĂȂ TRUE */
	Sint32		dma_sect;		/* cl`]ZN^ */
	Uint32		*write_addr;	/* ރAhX */
	Sint32		buf_bsize;		/* 󂫃obt@̃oCg */
	Sint32		write_bsize;	/* ]oCg */
	StmTrFunc	load_func;		/* ]֐ */
} CpkFileStmPara;

typedef struct {
	Sint32		faccess_type;		/* t@CANZX^Cv */
	/* t@C[Jf[^ */
	union	{
		CpkFileGfsPara	gfs;
		CpkFileStmPara	stm;
	} data;
} CpkFilePara;

/* s֐ */
typedef struct {
	void	(*start)(CpkHn cpk);
	void	(*task)(CpkHn cpk);
	Sint32	(*preload_movie)(CpkHn cpk, Sint32 size);
	void	(*set_load_num)(CpkHn cpk, Sint32 load_sct);
	void	(*set_trmode)(CpkHn cpk, CpkTrMode mode);
} CpkExecFunc;


typedef struct {
	CpkPara 	para;					/* bNp[^ */
	CpkStatus 	status;					/* eԁiJj 		*/
	CpkHeader 	*header;				/* tBt@Cwb_ 		*/
	CpkFilePara	filepara;				/* t@CANZXp[^	*/
	CpkExecFunc	execfunc;				/* s֐						*/
#if 1
	Uint32		*cbtblp[4];				/* ޯڽðْ߲ 	*/
	Uint32		cbtbl1a[256];			/* ޯڽð 			*/
	Uint32		cbtbl2a[256];			/* 								*/
	Uint32		cbtbl1b[256];			/* 								*/
	Uint32		cbtbl2b[256];			/* 								*/
#endif
	Uint32 		code_book[4 * CPK_DSIZE_CODE1BOOK_FUL];
										/* i code1book, code2book	*/
										/* i code1book, code2book	*/
} CpkWork;


/*-------------------------- s֐錾t --------------------------*/
/* Cȕ */
Bool CPK_Init(void);

/* CȕI */
void CPK_Finish(void);

/* nh̍쐬ij */
CpkHn CPK_CreateMemMovie(CpkCreatePara *para);

/* nh̏ij */
void CPK_DestroyMemMovie(CpkHn cpk);

/* nh̍쐬it@CVXej */
CpkHn CPK_CreateGfsMovie(CpkCreatePara *para, GfsHn gfs);

/* nh̏it@CVXej */
void CPK_DestroyGfsMovie(CpkHn cpk);

/* nh̍쐬iXg[VXej */
CpkHn CPK_CreateStmMovie(CpkCreatePara *para, StmHn stm);

/* nh̏iXg[VXej */
void CPK_DestroyStmMovie(CpkHn cpk);

/* Đ^XN */
void CPK_Task(CpkHn cpk);

/* \^C~O̔ */
Bool CPK_IsDispTime(CpkHn cpk);

/* \̒ʒm */
void CPK_CompleteDisp(CpkHn cpk);

/* uuNhm֐ */
void CPK_VblIn(void);

/* ĐJn */
void CPK_Start(CpkHn cpk);

/* Đ~ */
void CPK_Stop(CpkHn cpk);

/* ꎞ~ */
void CPK_Pause(CpkHn cpk, CpkPauseCmd cmd);

/* ɍĐ郀[r̓o^ */
void CPK_EntryNext(CpkHn cpk);

/* [r̋؂ւ */
void CPK_Change(void);

/* [r̐؂ւԂ̎擾 */
CpkChangeStatus CPK_CheckChange(void);

/* wt[̓WJ */
void CPK_DecodeFrame(CpkHn cpk, Sint32 frame_no);

/* WJAhX̐ݒ */
void CPK_SetDecodeAddr(CpkHn cpk, void *dec_addr, Sint32 dec_line_size);

/* \F̐ݒ */
void CPK_SetColor(CpkHn cpk, CpkColorType color);

/* ő]ZN^̐ݒ */
void CPK_SetLoadNum(CpkHn cpk, Sint32 read_sct);

/* Đo`m̐ݒ */
void CPK_SetPan(CpkHn cpk, Sint32 pan);

/* Đ{[̐ݒ */
void CPK_SetVolume(CpkHn cpk, Sint32 volume);

/* oblR}hubNԍ̐ݒ */
void CPK_SetPcmCmdBlockNo(CpkHn cpk, Sint32 blk_no);

/* oblXg[ԍ̐ݒ */
void CPK_SetPcmStreamNo(CpkHn cpk, Sint32 stream_no);

/* L[AEgiɂFj͈͂̐ݒ */
void CPK_SetKeyOutRange(CpkHn cpk, Sint32 range);

/* f[^̓]̐ݒibcubNOobt@j */
void CPK_SetTrModeCd(CpkHn cpk, CpkTrMode mode);

/* f[^̓]̐ݒiOobt@oblobt@j */
void CPK_SetTrModePcm(CpkHn cpk, CpkTrMode mode);

/* ^CXP[̎擾 */
Sint32 CPK_GetTimeScale(CpkHn cpk);

/* Đ̎擾 */
Sint32 CPK_GetTime(CpkHn cpk);

/* ĐXe[^X̎擾 */
CpkPlayStatus CPK_GetPlayStatus(CpkHn cpk);

/* tBwb_̃AhX̎擾 */
CpkHeader *CPK_GetHeader(CpkHn cpk);

/* ݃obt@AhX̎擾 */
Uint32 *CPK_GetWriteBuf(CpkHn cpk, Sint32 *free_size, Sint32 *free_total);

/* obt@ւ̏݃TCY̒ʒm */
void CPK_NotifyWriteSize(CpkHn cpk, Sint32 write_size);

/* Ƀ[rǂݍ */
Sint32 CPK_PreloadMovie(CpkHn cpk, Sint32 size);

/* ɃtBwb_ǂݍ */
Sint32 CPK_PreloadHeader(CpkHn cpk);

/* G[֐̓o^ */
void CPK_SetErrFunc(CpkErrFunc func, void *obj);

/* G[̎擾 */
CpkErrCode CPK_GetErr(void);




#endif	/* SEGA_CPK_H */
